/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.elsosystems.javawsklient;

import java.util.GregorianCalendar;
import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;
import javax.xml.ws.BindingProvider;
import javax.xml.ws.soap.AddressingFeature;
import vlozzaznamws.IVlozZaznamContract;
import vlozzaznamws.VZOdpoved;
import vlozzaznamws.VZRodneCisloPozadavek;
import vlozzaznamws.VlozZaznam;
import vyhledaniws.IVyhledaniContract;
import vyhledaniws.Vyhledani;
import vyhledaniws.VyhledaniOdpoved;
import vyhledaniws.VyhledaniPozadavek;


/**
 *
 * @author kamil
 */
public class WSClient {
    
    public static void main(String[] args)
    {
        //URL endpointů
        String vyhledaniUrl = "https://eregws2.ksrzis.cz/Registr/NROVDK/Vyhledani/";
        String vlozZaznamUrl = "https://eregws2.ksrzis.cz/Registr/NROVDK/VlozZaznam/";
        
        try
        {
            //Definice ObjectFactory pro jednodušší práci s parametry volání služeb.
            vyhledaniws.ObjectFactory vyhledaniFactory = new vyhledaniws.ObjectFactory();
            vlozzaznamws.ObjectFactory vlozzaznamFactory = new vlozzaznamws.ObjectFactory();
            
            Vyhledani vyhledaniPort = new Vyhledani();                        
            VlozZaznam vlozZaznamPort = new VlozZaznam(); 

            IVyhledaniContract vyhledaniContract = vyhledaniPort.getWSHttpBindingIVyhledaniContract(new AddressingFeature());
            IVlozZaznamContract vlozZaznamContract = vlozZaznamPort.getWSHttpBindingIVlozZaznamContract(new AddressingFeature());
            
            //Nastavení URL endpointů
            ((BindingProvider)vyhledaniContract).getRequestContext().put(BindingProvider.ENDPOINT_ADDRESS_PROPERTY, vyhledaniUrl);   
            
            ((BindingProvider)vlozZaznamContract).getRequestContext().put(BindingProvider.ENDPOINT_ADDRESS_PROPERTY, vlozZaznamUrl);   

            //Vytvoření požadavku na Vyhledani
            VyhledaniPozadavek vyhledaniPozadavek = new VyhledaniPozadavek();    
            vyhledaniPozadavek.setJmeno(vyhledaniFactory.createVyhledaniPozadavekJmeno("Jindřich"));
            vyhledaniPozadavek.setPrijmeni(vyhledaniFactory.createVyhledaniPozadavekPrijmeni("Velebný"));
            vyhledaniPozadavek.setRodneCislo(vyhledaniFactory.createVyhledaniPozadavekRodneCislo("6606166468"));
                        
            GregorianCalendar kalednar = new GregorianCalendar();
            DatatypeFactory datatypeFactory = DatatypeFactory.newInstance();
            XMLGregorianCalendar now = datatypeFactory.newXMLGregorianCalendar(kalednar);
            
            //Vytvoření požadavku na VlozZaznam
            VZRodneCisloPozadavek vlozZaznamPozadavek = new VZRodneCisloPozadavek();
            vlozZaznamPozadavek.setJmeno(vlozzaznamFactory.createVZRodneCisloPozadavekJmeno("Test"));
            vlozZaznamPozadavek.setPrijmeni(vlozzaznamFactory.createVZRodneCisloPozadavekPrijmeni("Testovič"));
            vlozZaznamPozadavek.setRodneCislo(vlozzaznamFactory.createVZRodneCisloPozadavekRodneCislo("6002204791"));
            vlozZaznamPozadavek.setDuvodVylouceniKod(vlozzaznamFactory.createVZRodneCisloPozadavekDuvodVylouceniKod("HPB"));
            vlozZaznamPozadavek.setDatumVylouceni(now);

            System.out.println("Volání služby \"Vyhledani\"...");
            
            //Provolání služby Vyhledani
            VyhledaniOdpoved vyhledaniOdpoved = vyhledaniContract.vyhledat(vyhledaniPozadavek);
            
            System.out.println("Odpověď: " + (vyhledaniOdpoved != null ? vyhledaniOdpoved.getJmeno().getValue() + " " + vyhledaniOdpoved.getPrijmeni().getValue() : "nenalezen" ));
            
            System.out.println("Volání služby \"VlozZaznam\"...");            

            //Provolání služby Vyhledani
            VZOdpoved vlozZaznamOdpoved = vlozZaznamContract.vytvorZaznamRodneCislo(vlozZaznamPozadavek);
                        
            System.out.println("Odpověď: " + (vlozZaznamOdpoved != null ? vlozZaznamOdpoved.getMessage().getValue() : "nic"));
        
        } catch (Exception ex) {            
            System.out.println("Chyba: ");
            System.out.println(ex);
        }                
    }
}
